/**
 *  Sankey Diagram Generator
 *  by Sam Brenner
 *  February 23, 2009
 *  v0.6
 */


class EndTextDrawer
{
  ArrayList endEndPoints;
  float averageOffset;
  
  EndTextDrawer()
  {
    endEndPoints = new ArrayList();
    remapEndValues();
    drawValues();
  }
  
  void remapEndValues()
  {
    for( int i = 0; i < endStartPoints.size(); i++ )
    {
      PVector temp = (PVector) endStartPoints.get( i );
      lowEndpointStartY = ( temp.y < lowEndpointStartY ) ? temp.y : lowEndpointStartY;
      highEndpointStartY = ( temp.y > highEndpointStartY ) ? temp.y : highEndpointStartY;
    } 
    
    averageOffset = ( (highEndpointStartY + 100) - (lowEndpointStartY - 100) ) / endText.size();
 
    for( int j = 0; j < endStartPoints.size(); j++ )
    {
      PVector temp = (PVector) endStartPoints.get( j );
      float endY = (lowEndpointStartY - 100) + ( averageOffset * j );
      endEndPoints.add( new PVector( (deepestLevel+1) * branchWidth, endY ) );
    }       
  }
  
  void drawValues()
  {
    
    
    for( int i = 0; i < endEndPoints.size(); i++ )
    {
      PVector temp1 = (PVector) endStartPoints.get( i );
      PVector temp2 = (PVector) endEndPoints.get( i );
      String txt = (String) endText.get( i );
      
      float x1, y1, cx1, cy1, cx2, cy2, x2, y2;
      x1 = temp1.x + 10;
      y1 = temp1.y;
      cx1 = x1 + bezierOffset;
      cy1 = y1;
      
      x2 = temp2.x + (300);
      y2 = temp2.y;
      cx2 = x2 - bezierOffset;
      cy2 = y2;
      
      strokeWeight( 1 );
      stroke( 0, 30 );
      noFill();
      bezier( x1, y1, cx1, cy1, cx2, cy2, x2, y2 );
      
      textAlign( LEFT );
      fill( 0 );
      textFont( din );
      text( txt, x2+5, y2+2 );
    } 
  }
}
